#include <bits/stdc++.h>

#define int long long
#define F first
#define ld long double
#define S second
using namespace std;

struct Vector {
    ld x, y;

    void in() {
        cin >> x >> y;
    }

    Vector operator-(Vector a) {
        return {x - a.x, y - a.y};
    }

    Vector operator+(Vector a) {
        return {x + a.x, y + a.y};
    }

    Vector operator*(ld k) {
        return {x * k, y * k};
    }

    ld operator*(Vector a) {
        return x * a.x + y * a.y;
    }

    ld operator%(Vector a) {
        return x * a.y - y * a.x;
    }

    ld len2() {
        return x * x + y * y;
    }

    ld len() {
        return sqrtl(len2());
    }
};

struct line {
    ld a, b, c;

    ld dist(Vector p) {
        return fabs(a * p.x + b * p.y + c) / sqrt(a * a + b * b);
    }
};

line geteq(Vector a, Vector b) {
    ld A = a.y - b.y;
    ld B = b.x - a.x;
    ld C = -A * a.x - B * a.y;
    return {A, B, C};
}

map<pair<int, int>, ld> s;
const ld pi = 3.14159265358979323846;

ld getang(Vector a, Vector b, Vector c) {
    a = a - b;
    c = c - b;
    ld ang = atan2(a % c, a * c);
    if (ang < 0) {
        ang = 2 * pi - ang;
    }
    return ang;
}

const ld eps = 1e-9;
ld ans = LLONG_MAX;
vector<bool> used;
vector<int> ord;

void rec(int now) {
    if (now == used.size()) {
        ld p = 0;
        bool bad = 0;
        for (int i = 0; i < (int) ord.size() - 1; ++i) {
            if (!s.count({ord[i], ord[i + 1]})) {
                bad = 1;
                break;
            }
            p += s[{ord[i], ord[i + 1]}];
        }
        if (!bad) {
            ans = min(ans, p);
        }
        return;
    }
    for (int i = 0; i < used.size(); ++i) {
        if (!used[i]) {
            used[i] = 1;
            ord.push_back(i);
            rec(now + 1);
            ord.pop_back();
            used[i] = 0;
        }
    }
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int n;
    cin >> n;
    vector<Vector> a(n);
    for (int i = 0; i < n; ++i) {
        a[i].in();
    }
    vector<Vector> all;
    for (auto i : a) {
        all.push_back(i);
    }
    vector<line> ls;
    for (int i = 0; i < n; ++i) {
        for (int j = i + 1; j < n; ++j) {
            line p = geteq(a[i], a[j]);
            ls.push_back(p);
            Vector per = a[j] - a[i];
            per = {per.y, -per.x};
            p = geteq(a[i], a[i] + per);
            ls.push_back(p);
        }
    }
    for (int i = 0; i < n; ++i) {
        for (auto &l : ls) {
            Vector per = {l.a, l.b};
            per = per * l.dist(a[i]);
            Vector p = a[i] + per;
            if (l.dist(p) > l.dist(a[i])) {
                p = a[i] - per;
            }
            all.push_back(p);
        }
    }
    for (int i = 0; i < all.size(); ++i) {
        for (int j = 0; j < all.size(); ++j) {
            for (int k = 0; k < all.size(); ++k) {
                if (i == j || k == j || i == k) {
                    if (!s.count({i, k})) {
                        s[{i, k}] = (all[i] - all[j]).len() + (all[k] - all[j]).len();
                    } else {
                        s[{i, k}] = min(s[{i, k}], (all[i] - all[j]).len() + (all[k] - all[j]).len());
                    }
                    continue;
                }
                ld ang = getang(all[i], all[j], all[k]);
                if (fabs(ang) < eps || fabs(ang - 2 * pi) < eps || fabs(ang - pi) < eps || fabs(ang - pi / 2) < eps ||
                    fabs(ang - pi - pi / 2) < eps) {
                    if (!s.count({i, k})) {
                        s[{i, k}] = (all[i] - all[j]).len() + (all[k] - all[j]).len();
                    } else {
                        s[{i, k}] = min(s[{i, k}], (all[i] - all[j]).len() + (all[k] - all[j]).len());
                    }
                }
            }
        }
    }
    used.resize(n);
    rec(0);
    cout << fixed << setprecision(15);
    cout << ans;
    return 0;
}