#include <bits/stdc++.h>

#define int long long
#define F first
#define ld long double
#define S second
using namespace std;

struct Vector {
    ld x, y;

    void in() {
        cin >> x >> y;
    }

    Vector operator-(Vector a) {
        return {x - a.x, y - a.y};
    }

    Vector operator+(Vector a) {
        return {x + a.x, y + a.y};
    }

    Vector operator*(ld k) {
        return {x * k, y * k};
    }

    ld operator*(Vector a) {
        return x * a.x + y * a.y;
    }

    ld operator%(Vector a) {
        return x * a.y - y * a.x;
    }

    ld len2() {
        return x * x + y * y;
    }

    ld len() {
        return sqrtl(len2());
    }

    ld manh() {
        return fabs(x) + fabs(y);
    }
};

ld ans = LLONG_MAX;
int n;
vector<Vector> a;
vector<bool> used;

vector<int> ord;

void rec(int now) {
    if (now == n) {
        ld p = 0;
        for (int i = 0; i < n - 1; ++i) {
            p += (a[ord[i]] - a[ord[i + 1]]).manh();
        }
        ans = min(ans, p);
        return;
    }
    for (int i = 0; i < n; ++i) {
        if (!used[i]) {
            used[i] = 1;
            ord.push_back(i);
            rec(now + 1);
            ord.pop_back();
            used[i] = 0;
        }
    }
}

const ld eps = 1e-2;
const ld pi = 3.14159265358979323846;
Vector zero = {1, 0};

Vector turn(Vector v, ld ang) {
    ld f = v.len();
    v = v * (1.0 / f);
    ld an = atan2(zero % v, zero * v);
    if (an < 0) {
        an += 2 * pi;
    }
    an += ang;
    ld x = cos(an), y = sin(an);
    Vector nv = {x, y};
    return nv * f;
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout << fixed << setprecision(15);
    cin >> n;
    a.resize(n);
    for (int i = 0; i < n; ++i) {
        a[i].in();
    }
    if (n == 2) {
        cout << (a[0] - a[1]).len();
        return 0;
    }
    used.resize(n);
    vector<ld> angles;
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < n; ++j) {
            Vector p = a[i] - a[j];
            ld ang = atan2(zero % p, zero * p);
            if (ang < 0) {
                ang += 2 * pi;
            }
            angles.push_back(2 * pi - ang);
            angles.push_back(ang);
            angles.push_back(pi - ang);
            angles.push_back(pi / 2 - ang);
        }
    }
    for (ld ang : angles) {
        vector<Vector> b = a;
        for (int i = 0; i < n; ++i) {
            a[i] = turn(a[i], ang);
        }
        rec(0);
        a = b;
    }
    cout << ans;
    return 0;
}